// --------------------- interface functions ---------------------


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_Linux.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SCHED_SETSCHEDULER     _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_ATTACH                 _IOW(BOSSA_ID_NUM, 1, int)
#define BOSSA_DEVICE_NAME "bossa_Linux"


struct dev_Linux_sched_setscheduler_struct {
  int p;
  enum policy_t policy;
  int prio;
};

struct dev_Linux_attach_struct {
  int p_9;
  enum policy_t policy_10;
  int rt_priority_11;
  int priority_12;
};

int Linux_sched_setscheduler(int p, enum policy_t policy, int prio) {
  struct dev_Linux_sched_setscheduler_struct _data;
  _data.p = p;
  _data.policy = policy;
  _data.prio = prio;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SCHED_SETSCHEDULER,(char *)&_data);
    if (res) perror("sched_setscheduler");
    close(fd);
    return res;
  }
}

int Linux_attach(int p_9, enum policy_t policy_10, int rt_priority_11,
                 int priority_12) {
  struct dev_Linux_attach_struct _data;
  _data.p_9 = p_9;
  _data.policy_10 = policy_10;
  _data.rt_priority_11 = rt_priority_11;
  _data.priority_12 = priority_12;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}
