// --------------------- interface functions ---------------------


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_Proportion.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_SET_PERIOD      _IOW(BOSSA_ID_NUM, 0, int)
#define IOCTL_START_TRACE     _IOW(BOSSA_ID_NUM, 1, int)
#define IOCTL_END_TRACE       _IOW(BOSSA_ID_NUM, 2, int)
#define BOSSA_DEVICE_NAME "bossa_Proportion"


struct dev_Proportion_attach_struct {
  struct Proportion_bossa_struct * s_9;
  TypeProp prop_10;
};

struct dev_Proportion_set_period_struct {
  int new_period;
};

int Proportion_set_period(int new_period) {
  struct dev_Proportion_set_period_struct _data;
  _data.new_period = new_period;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_SET_PERIOD,(char *)&_data);
    if (res) perror("set_period");
    close(fd);
    return res;
  }
}

int Proportion_start_trace(void) {
  int _data;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_START_TRACE,(char *)&_data);
    if (res) perror("start_trace");
    close(fd);
    return res;
  }
}

int Proportion_end_trace(void) {
  int _data;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_END_TRACE,(char *)&_data);
    if (res) perror("end_trace");
    close(fd);
    return res;
  }
}
