// --------------------- interface functions ---------------------


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "user_Timer.h"


#define BOSSA_ID_NUM 0xCE
#define IOCTL_ATTACH     _IOW(BOSSA_ID_NUM, 0, int)
#define BOSSA_DEVICE_NAME "bossa_Timer"


struct dev_Timer_attach_struct {
  int p_9;
  unsigned long delay1_10;
  unsigned long delay2_11;
};

int Timer_attach(int p_9, unsigned long delay1_10, unsigned long delay2_11) {
  struct dev_Timer_attach_struct _data;
  _data.p_9 = p_9;
  _data.delay1_10 = delay1_10;
  _data.delay2_11 = delay2_11;
  {
    int fd, res;
    fd = open("/dev/bossa/" BOSSA_DEVICE_NAME, O_WRONLY);
    res = ioctl(fd,IOCTL_ATTACH,(char *)&_data);
    if (res < 0) perror("attach");
    close(fd);
    return res;
  }
}
